%DEFINE (FOR_SDCC)    (0)     ; The SDCC ASX8051 is used

%IF(%FOR_SDCC)THEN(
;EXTRN	CODE(__sdcc_external_startup)
EXTRN	CODE(s_GSINIT)
)ELSE(
EXTRN CODE(?C_START)
)FI
PUBLIC	VEC_SET,VEC_USR,VEC_GET

; Vector array base address
%DEFINE (VEC_BA) (8400H)

VEC_ARR XDATA %VEC_BA
VEC_CAR CODE %VEC_BA

%IF(1)THEN(
CSEG AT 8400H
%IF(%FOR_SDCC)THEN(
	LJMP  s_GSINIT
)ELSE(
	JMP   VECT_STARTUP
)FI
)ELSE(
CSEG AT 0000H
%IF(%FOR_SDCC)THEN(
	LJMP  s_GSINIT
)ELSE(
	JMP   ?C_START
)FI
	JMP   VEC_CAR+03H ;  EXTI0
	JMP   VEC_CAR+06H ;  SYS_FNC
	DS    2
	JMP   VEC_CAR+0BH ;  TIMER0
	JMP   VEC_CAR+0EH ;
	DS    2
	JMP   VEC_CAR+13H ;  EXTI1
	JMP   VEC_CAR+16H ;
	DS    2
	JMP   VEC_CAR+1BH ;  TIMER1
	JMP   VEC_CAR+1EH ;  V_uL_ADD
	DS    2
	JMP   VEC_CAR+23H ;  SINT
	JMP   VEC_CAR+26H ;  V_uL_FNC
	DS    2
	JMP   VEC_CAR+2BH ;  SIIC
	JMP   VEC_CAR+2EH ;
	DS    2
	JMP   VEC_CAR+33H ;  T2CAP0
	JMP   VEC_CAR+36H ;
	DS    2
	JMP   VEC_CAR+3BH ;  T2CAP1
	JMP   VEC_CAR+3EH ;
	DS    2
	JMP   VEC_CAR+43H ;  T2CAP2
	JMP   VEC_CAR+46H ;
	DS    2
	JMP   VEC_CAR+4BH ;  T2CAP3
	JMP   VEC_CAR+4EH ;
	DS    2
	JMP   VEC_CAR+53H ;  ADCINT
	JMP   VEC_CAR+56H ;
	DS    2
	JMP   VEC_CAR+5BH ;  T2CMP0
	JMP   VEC_CAR+5EH ;
	DS    2
	JMP   VEC_CAR+63H ;  T2CMP1
	JMP   VEC_CAR+66H ;
	DS    2
	JMP   VEC_CAR+6BH ;  T2CMP2
	JMP   VEC_CAR+6EH ;
	DS    2
	JMP   VEC_CAR+73H ;  TIMER2
	JMP   VEC_CAR+76H ;
	DS    2
	JMP   VEC_CAR+7BH ;

)FI

VECT__C SEGMENT CODE

RSEG	VECT__C

%IF(%FOR_SDCC)THEN(
; Startup code for SDCC
)ELSE(
; Startup code for Keil
VECT_STARTUP:
	CLR   EA
	MOV   IE,#0
	MOV   SP,#0C0H
	JMP   ?C_START
)FI

VEC_SET:MOV   A,R4
        MOV   R4,DPL
        MOV   R5,DPH
    %IF(0)THEN(
        MOV   DPTR,#VEC_ARR
        CALL  ADDATDP
    )ELSE(
	ADD   A,#LOW VEC_ARR
	MOV   DPL,A
	CLR   A
	ADDC  A,#HIGH VEC_ARR
	MOV   DPH,A
    )FI
VEC_USR:MOV   A,#2
        MOV   C,EA
        CLR   EA
        MOVX  @DPTR,A
        INC   DPTR
        MOVX  A,@DPTR
        XCH   A,R5
        MOVX  @DPTR,A
        INC   DPTR
        MOVX  A,@DPTR
        XCH   A,R4
        MOVX  @DPTR,A
        MOV   EA,C
        RET

VEC_GET:MOV   DPL,R4
        MOV   DPH,#HIGH VEC_ARR
        INC   DPTR
        MOVX  A,@DPTR
        MOV   R5,A
        INC   DPTR
        MOVX  A,@DPTR
        MOV   R4,A
        RET

        END
