/***************************************************************/
/***   Module : modified standard io library - header file   ***/
/***   Author : Roman Bartosinski (C) 28.04.2002             ***/
/***   Modify : 08.08.2002                                   ***/
/***************************************************************/

#ifndef _STDIO_MODULE_FOR_DISPLAY_I51
  #define _STDIO_MODULE_FOR_DISPLAY_I51

  void putchar( unsigned char chr);

  typedef struct _tag_printf_data {
    char *Str;
    unsigned int Par[5];
  } PRINTF, *PPRINTF;

  extern xdata PRINTF vData;

 #if 1
  #define printf(str) { vData.Str = str; WriteText();}
  #define printf1(str,p0) { vData.Str = str; vData.Par[0] = (unsigned int)p0; WriteText();}
  #define printf2(str,p0,p1) { vData.Str = str; vData.Par[0] = (unsigned int)p0; vData.Par[1] = (unsigned int)p1; WriteText();}
  #define printf3(str,p0,p1,p2) { vData.Str = str; vData.Par[0] = (unsigned int)p0; vData.Par[1] = (unsigned int)p1; vData.Par[2] = (unsigned int)p2; WriteText();}
  #define printf4(str,p0,p1,p2,p3) { vData.Str = str; vData.Par[0] = (unsigned int)p0; vData.Par[1] = (unsigned int)p1; vData.Par[2] = (unsigned int)p2; vData.Par[3] = (unsigned int)p3; WriteText();}
  #define printf5(str,p0,p1,p2,p3,p4) { vData.Str = str; vData.Par[0] = (unsigned int)p0; vData.Par[1] = (unsigned int)p1; vData.Par[2] = (unsigned int)p2; vData.Par[3] = (unsigned int)p3; vData.Par[4] = (unsigned int)p4; WriteText();}
 #else
  #include <stdio.h>
  #define printf1 printf
  #define printf2 printf
  #define printf3 printf
  #define printf4 printf
  #define printf5 printf
 #endif
 
  void WriteBin( unsigned int num);
  void WriteHexLarge( unsigned int num);
  void WriteDec( int num);
  void WriteText( void);

  unsigned char chstrlen( char *str);

#endif
