for_sdcc = 1     ; the sdcc asx8051 is used

.if for_sdcc
;.globl __sdcc_external_startup ; code
.globl s_GSINIT ; code
.else 
.globl ?c_start ; code
.endif 
.globl	vec_set,vec_usr,vec_get

; vector array base address
vec_ba = 0x8400

vec_arr=vec_ba ;xdata 
vec_car=vec_ba ;code 

.if 0
.area CSEG_A (ABS,CODE)
.org 0x8000
	;ljmp  __sdcc_external_startup  
	ljmp  s_GSINIT
.else 
.area CSEG_A (ABS,CODE)
.org 0x0000
.if for_sdcc
	ljmp  s_GSINIT
.else 
	ljmp   ?c_start
.endif 
	ljmp   vec_car+0x03 ;  exti0
	ljmp   vec_car+0x06 ;  sys_fnc
	.ds    2
	ljmp   vec_car+0x0b ;  timer0
	ljmp   vec_car+0x0e ;
	.ds    2
	ljmp   vec_car+0x13 ;  exti1
	ljmp   vec_car+0x16 ;
	.ds    2
	ljmp   vec_car+0x1b ;  timer1
	ljmp   vec_car+0x1e ;  v_ul_add
	.ds    2
	ljmp   vec_car+0x23 ;  sint
	ljmp   vec_car+0x26 ;  v_ul_fnc
	.ds    2
	ljmp   vec_car+0x2b ;  siic
	ljmp   vec_car+0x2e ;
	.ds    2
	ljmp   vec_car+0x33 ;  t2cap0
	ljmp   vec_car+0x36 ;
	.ds    2
	ljmp   vec_car+0x3b ;  t2cap1
	ljmp   vec_car+0x3e ;
	.ds    2
	ljmp   vec_car+0x43 ;  t2cap2
	ljmp   vec_car+0x46 ;
	.ds    2
	ljmp   vec_car+0x4b ;  t2cap3
	ljmp   vec_car+0x4e ;
	.ds    2
	ljmp   vec_car+0x53 ;  adcint
	ljmp   vec_car+0x56 ;
	.ds    2
	ljmp   vec_car+0x5b ;  t2cmp0
	ljmp   vec_car+0x5e ;
	.ds    2
	ljmp   vec_car+0x63 ;  t2cmp1
	ljmp   vec_car+0x66 ;
	.ds    2
	ljmp   vec_car+0x6b ;  t2cmp2
	ljmp   vec_car+0x6e ;
	.ds    2
	ljmp   vec_car+0x73 ;  timer2
	ljmp   vec_car+0x76 ;
	.ds    2
	ljmp   vec_car+0x7b ;

.endif 

;vect__c segment code

.area CSEG (CODE) ;vect__c

vec_set:mov   a,r4
        mov   r4,dpl
        mov   r5,dph
.if 0
        mov   dptr,#vec_arr
        lcall  addatdp
.else 
	add   a,#< vec_arr
	mov   dpl,a
	clr   a
	addc  a,#> vec_arr
	mov   dph,a
.endif 
vec_usr:mov   a,#2
        mov   c,ea
        clr   ea
        movx  @dptr,a
        inc   dptr
        movx  a,@dptr
        xch   a,r5
        movx  @dptr,a
        inc   dptr
        movx  a,@dptr
        xch   a,r4
        movx  @dptr,a
        mov   ea,c
        ret

vec_get:mov   dpl,r4
        mov   dph,#> vec_arr
        inc   dptr
        movx  a,@dptr
        mov   r5,a
        inc   dptr
        movx  a,@dptr
        mov   r4,a
        ret

        
